
#property copyright "Copyright Trading"
#property link      "mailto:ericy88@gmail.com"
#property indicator_chart_window
#property indicator_plots 0
#property indicator_buffers 1


#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>  
#include <MT4orders.mqh>

CTrade         m_trade;                      // trading object
CSymbolInfo    m_symbol;                     // symbol info object

//--- input parameters
sinput string           _0_="*-*-*-*-*-*"; // Global parameters
input int               shift_high        = 0;
input int               shift_low         = 0;
input uchar             count_day=30;  // count day "0" -> current day
sinput string           _1_="*-*-*-*-*-*"; // High Level parameters
//--- input parameters of the script 
input color             InpColorHigh         = clrBlue;        // Line color 
input ENUM_LINE_STYLE   InpStyleHigh         = STYLE_DASH;     // Line style 
input int               InpWidthHigh         = 1;              // Line width 
sinput string           _2_="Low Level parameters";
//--- input parameters of the script 
input color             InpColorLow          = clrRed;         // Line color 
input ENUM_LINE_STYLE   InpStyleLow          = STYLE_DASH;     // Line style 
input int               InpWidthLow          = 1;              // Line width 
//---
string name_high="High Level";
string name_low="Low Level";
//---
double         m_adjusted_point;             // point value adjusted for 3 or 5 points

input double     StartingLot_ = 0.01;
input int        SpaceBetweenTrades_ = 2;
input int        FirstOrderFromMarket_ = 10;
input int        NumberOfTrades_ = 200;
input bool        TradeLong_ = true;
input bool        TradeShort_ = true;
input int         Magic_ = 11235;
input double      LotSizeMultiplier_ = 1.03;
input int        IM_ = 30; //initial market move
input int        Y_ = 50; //TP when market moves less than IM
input int        Z_ = 50; //TP when market moves more than IM

input bool       EnableSL_ = true;
input int        mSL1= 300; // modify SL from breakeven when EnbleSL=true
input int        iTP2 = 50;  //initial TP
input int        iSL3 = 300;  //initial SL
input double     rTP4=50; //Range distribution of TP
input double     rSL5=5; //Range distribution of SL

extern double     StartingLot = StartingLot_;
extern int        SpaceBetweenTrades = SpaceBetweenTrades_;
extern int        FirstOrderFromMarket = FirstOrderFromMarket_;
extern int        NumberOfTrades = NumberOfTrades_;
extern bool        TradeLong = TradeLong_;
extern bool        TradeShort = TradeShort_;
extern double      LotSizeMultiplier = LotSizeMultiplier_;
extern int        IM = IM_; //initial market move
extern int        Y = Y_; //TP when market moves less than IM
extern int        Z = Z_; //TP when market moves more than IM

extern bool       EnableSL = EnableSL_;
extern int        mSL= mSL1;
extern int        iTP = iTP2;
extern int        iSL = iSL3;
extern double     rTP=rTP4;
extern double     rSL=rSL5;

double btp=0; //Buy Take Profit Price
double bsl=0; //Buy Stop Loss Price
double stp=0; //Sell Take Profit Price
double ssl=0; //Sell Stop Loss Price
double lastBE = 0;
double lastActive = 0;
int     POS_n_BUY;
int     POS_n_SELL;
int     POS_n_BUYLIMIT;
int     POS_n_SELLLIMIT;
int     POS_n_total;
double StartAskPrice = 0;
double StartBidPrice = 0;         
ulong  m_slippage=30;   // slippage    
double HighLevelPrice = 0;
double LowLevelPrice = 0;

int OnInit()
  {
     if (Digits() == 3 || Digits() == 5)
      {
         IM  = IM  * 10;
         Y = Y * 10;
         Z = Z * 10;
         mSL= mSL* 10;
         iTP = iTP * 10;
         iSL = iSL * 10;
         SpaceBetweenTrades = SpaceBetweenTrades * 10;
         FirstOrderFromMarket = FirstOrderFromMarket * 10;
      }
      StartAskPrice = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      StartBidPrice = SymbolInfoDouble(_Symbol,SYMBOL_BID);
      m_trade.SetExpertMagicNumber(Magic_);
      
//--- tuning for 3 or 5 digits
   int digits_adjust=1;
   if(Digits()==3 || Digits()==5)
      digits_adjust=10;
   m_adjusted_point=Point()*digits_adjust;
//---
   if(ObjectFind(0,name_high)<0)
      HLineCreate(0,name_high,0,0.0,InpColorHigh,InpStyleHigh,InpWidthHigh);
   if(ObjectFind(0,name_low)<0)
      HLineCreate(0,name_low,0,0.0,InpColorLow,InpStyleLow,InpWidthLow);
//---
   MqlRates rates_array[];
   CopyRates(Symbol(),PERIOD_D1,0,count_day,rates_array);
//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Indicator deinitialization function                              |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   Print(__FUNCTION__,", ",reason);
   if(reason==1) // REASON_REMOVE
     {
      HLineDelete(0,name_high);
      HLineDelete(0,name_low);
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   static int number=-9;
   number++;
   if(number%50==0)
     {
      //Comment(number);
      number=0;
     }
   else
     {
      //Comment(number);
      return(rates_total);
     }
//---
   double High[];
   double Low[];
   int count=(count_day==0)?1:count_day;
   CopyHigh(Symbol(),PERIOD_D1,0,count,High);
   CopyLow(Symbol(),PERIOD_D1,0,count,Low);
   static double price_high=0.0;
   static double price_low=0.0;
   if(count_day>0)
     {
      price_high=High[ArrayMaximum(High,0,WHOLE_ARRAY)];
      price_low=Low[ArrayMinimum(Low,0,WHOLE_ARRAY)];
     }
   else
     {
      price_high=High[0];
      price_low=Low[0];
     }
   price_high+=shift_high*m_adjusted_point;
   price_low+=shift_low*m_adjusted_point;

   if(ObjectFind(0,name_high)<0)
      HLineCreate(0,name_high,0,0.0,InpColorHigh,InpStyleHigh,InpWidthHigh);
   HLineMove(0,name_high,price_high);

   if(ObjectFind(0,name_low)<0)
      HLineCreate(0,name_low,0,0.0,InpColorLow,InpStyleLow,InpWidthLow);
   HLineMove(0,name_low,price_low);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
  
void OnTick()
{
   if(!m_symbol.Name(Symbol())) // sets symbol name
      return;
   if(!RefreshRates())
      return;
//---
   if(IsFillingTypeAllowed(SYMBOL_FILLING_FOK))
      m_trade.SetTypeFilling(ORDER_FILLING_FOK);
   else if(IsFillingTypeAllowed(SYMBOL_FILLING_IOC))
      m_trade.SetTypeFilling(ORDER_FILLING_IOC);
   else
      m_trade.SetTypeFilling(ORDER_FILLING_RETURN);
//---
   m_trade.SetDeviationInPoints(m_slippage);
   m_trade.SetAsyncMode(true);
   
   int i ;
   double TradedLot;  
   double BuyPrice;
   double SellPrice;
   
   count_position();
   
   if(POS_n_BUY > 0){DeleteSellLimit();}
   if(POS_n_SELL > 0){DeleteBuyLimit();}  
   if (POS_n_BUY + POS_n_SELL > 0)
   {
      if (POS_n_BUY + POS_n_SELL > lastActive)
      {
         btp = 0;
         stp = 0;
         bsl = 0;
         ssl = 0;
         double BE = calculateBreakevenPrice2(); 
         
         checkTP(BE);
         setSL(BE);
         Print("BE : ",BE);
         ObjectDelete(0,"BE");
         ObjectCreate(0,"BE",OBJ_HLINE,0,0,NormalizeDouble(BE,Digits()));
         ObjectSetInteger(0,"BE",OBJPROP_COLOR,clrGreen);
         ObjectSetInteger(0,"BE",OBJPROP_STYLE,STYLE_SOLID);
         ObjectSetInteger(0,"BE",OBJPROP_WIDTH,2);
         
         Print("btp ",btp);
         Print("stp ",stp);
         Print("bsl ",bsl);
         Print("ssl ",ssl);
         
         mo();
         mo1();
         lastBE = BE;        
      }
   }
   else
   {
      if (lastActive > 0)
      {
         DeleteSellLimit();
         DeleteBuyLimit();
      }
   }
   
   lastActive = POS_n_BUY + POS_n_SELL;
     
   if(POS_n_BUYLIMIT + POS_n_SELLLIMIT + POS_n_BUY + POS_n_SELL == 0)
   {  
      TradedLot = StartingLot;      
      for(i=1;i<=NumberOfTrades;i++)
      { 
      RefreshRates();
      StartAskPrice = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
      StartBidPrice = SymbolInfoDouble(_Symbol,SYMBOL_BID); 
      HighLevelPrice = ObjectGetDouble(0,"name_high",OBJPROP_PRICE,0);
      LowLevelPrice =  ObjectGetDouble(0,"name_low",OBJPROP_PRICE,0);
      
      Print("HighLevelPrice ",HighLevelPrice);
      Print("LowLevelPrice ", LowLevelPrice);
      
      bool sellZone; 
      if(StartAskPrice > price_high) {sellZone = true;}
      else{(sellZone=false);}
      bool buyZone;
      if(StartBidPrice < LowLevelPrice) {buyZone = true;}
      else {(buyZone = false);}
     
      BuyPrice = StartBidPrice - FirstOrderFromMarket*_Point;
      SellPrice = StartAskPrice + FirstOrderFromMarket*_Point;
      double TradedBLevel = NormalizeDouble(BuyPrice - ((SpaceBetweenTrades * i)*_Point),_Digits);
      double TradedSLevel = NormalizeDouble(SellPrice + ((SpaceBetweenTrades * i)*_Point),_Digits);
      if(TradeLong && buyZone) 
      {
         double TP = NormalizeDouble(TradedBLevel + (iTP*_Point),_Digits);
         double SL = NormalizeDouble(TradedBLevel - (iSL*_Point),_Digits);
         if(TradedBLevel < SymbolInfoDouble(_Symbol,SYMBOL_ASK))
          m_trade.BuyLimit(NormalizeDouble(TradedLot,2),m_symbol.NormalizePrice(TradedBLevel),m_symbol.Name(),
                          m_symbol.NormalizePrice(SL),
                          m_symbol.NormalizePrice(TP));
          else
             m_trade.BuyStop(NormalizeDouble(TradedLot,2),m_symbol.NormalizePrice(TradedBLevel),m_symbol.Name(),
                 m_symbol.NormalizePrice(SL),
                 m_symbol.NormalizePrice(TP));
         }
        
      if(TradeShort && sellZone) 
      {
            double TP = NormalizeDouble(TradedSLevel - (iTP*_Point),_Digits);
            double SL = NormalizeDouble(TradedSLevel + (iSL*_Point),_Digits);
            if(TradedSLevel > SymbolInfoDouble(_Symbol,SYMBOL_BID))
            m_trade.SellLimit(NormalizeDouble(TradedLot,2),m_symbol.NormalizePrice(TradedSLevel),
                           m_symbol.Name(),
                           m_symbol.NormalizePrice(SL),
                           m_symbol.NormalizePrice(TP));
                           
            else
            m_trade.SellStop(NormalizeDouble(TradedLot,2),m_symbol.NormalizePrice(TradedSLevel),
               m_symbol.Name(),
               m_symbol.NormalizePrice(SL),
               m_symbol.NormalizePrice(TP));
         }           
         TradedLot = TradedLot * LotSizeMultiplier;
      }
 }          
}
//------------------------------------------
void count_position()
{
    POS_n_BUY  = 0;
    POS_n_SELL = 0;   
    POS_n_BUYLIMIT = 0;
    POS_n_SELLLIMIT = 0;    
    for( int i = 0 ; i < OrdersTotal() ; i++ )   
        if (OrderSelect(i,SELECT_BY_POS))
        {     
           if( OrderType() == OP_BUY  && OrderSymbol() == Symbol() && OrderMagicNumber()==Magic_){
               POS_n_BUY++;
           }
           else if( OrderType() == OP_SELL  && OrderSymbol() == Symbol() && OrderMagicNumber()==Magic_){
               POS_n_SELL++;
           }
           else if( OrderType() == OP_BUYLIMIT  && OrderSymbol() == Symbol() && OrderMagicNumber()==Magic_){
               POS_n_BUYLIMIT++;
           }
           else if( OrderType() == OP_SELLLIMIT  && OrderSymbol() == Symbol() && OrderMagicNumber()==Magic_){
               POS_n_SELLLIMIT++;
           }
        }
    POS_n_total = POS_n_BUY + POS_n_SELL + POS_n_BUYLIMIT + POS_n_SELLLIMIT;
}

void DeleteBuyLimit()
{
   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderType() == OP_BUYLIMIT && OrderMagicNumber() == Magic_)
             {
                int openticket = OrderDelete(OrderTicket());
             }
       }
   }
}

void DeleteSellLimit()
{
   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderType() == OP_SELLLIMIT && OrderMagicNumber() == Magic_)
             {
                int openticket = OrderDelete(OrderTicket());
             }
       }
   }
}

double calculateBreakevenPrice()
{
   double currentProfit = 0;
   double totalLot = 0;
   double closePrice = 0;
   
   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderType() < 2 && OrderMagicNumber() == Magic_)
             {
                  double profitPips = (OrderOpenPrice()-OrderClosePrice())/_Point;
                  currentProfit += (profitPips*OrderLots());
                   //My code
                  if (OrderType() == OP_BUY) {
                  totalLot += OrderLots();
                  }
                  else {
                  totalLot -=OrderLots();
                  }
                  closePrice = OrderClosePrice();
             }
       }
   }  
   double pointToBE = MathCeil(currentProfit/totalLot);
   return closePrice + (pointToBE * _Point);
}

double calculateBreakevenPrice2()
{
   double currentProfit = 0;
   double totalLot = 0; 
   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderType() < 2 && OrderMagicNumber() == Magic_)
             {
                  currentProfit += OrderProfit()+OrderCommission()+OrderSwap();
                   //My code
                  if (OrderType() == OP_BUY) {
                  totalLot += OrderLots();
                  }
                  else {
                  totalLot -=OrderLots();
                  }
             }
       }
   }  
   int dig=_Digits;
   double point=SymbolInfoDouble(_Symbol,SYMBOL_POINT);
   double COP =totalLot*SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE);
   double val = SymbolInfoDouble(_Symbol,SYMBOL_BID) - point*currentProfit / COP;
   double BEPrice=DoubleToString(val,dig);
   return BEPrice;
}

void checkTP(double BE)
{
   double openPrice = getFirstOrderOpenPrice();
   int type = getFirstOrderType();
   double currentPrice = iClose(Symbol(),0,0);
   double FPDiff;
   int TPPips = 0;
   
   if (type == 0)
   {
      FPDiff = ((POS_n_BUY-1)*SpaceBetweenTrades);      
      if (FPDiff <= IM )
      {
         Print("FPDiff " + DoubleToString(FPDiff) + " <= " + IntegerToString(IM) + " : " + IntegerToString(Y));
         TPPips = Y;
      }
      else if (FPDiff > IM)
      {
         Print("FPDiff " + DoubleToString(FPDiff) + " > " + IntegerToString(IM) + " : " + IntegerToString(Z));
         TPPips = Z; 
      }     
      btp = NormalizeDouble(BE + (TPPips * _Point),_Digits);        
   }
   else if (type == 1)
   {
      FPDiff = ((POS_n_SELL-1)*SpaceBetweenTrades);     
      if (FPDiff <= IM)
      {
         Print("FPDiff " + DoubleToString(FPDiff) + " <= " + IntegerToString(IM) + " : " + IntegerToString(Y));
         TPPips = Y;
      }
      else if (FPDiff > IM)
      {
         Print("FPDiff " + DoubleToString(FPDiff) + " > " + IntegerToString(IM) + " : " + IntegerToString(Z));
         TPPips = Z; 
      }       
      stp = NormalizeDouble(BE - (TPPips * _Point),_Digits);
   }
}

double getFirstOrderOpenPrice()
{
   datetime firstTime = D'2040.01.01';
   double firstOpenPrice = 0;

   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_)
             {
                if (OrderOpenTime() < firstTime)
                {
                  firstTime = OrderOpenTime();
                  firstOpenPrice = OrderOpenPrice();
                }
             }
       }
   } 
   return firstOpenPrice;
}

int getFirstOrderType()
{
   datetime firstTime = D'2040.01.01';
   int type = -1;

   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic_)
             {
                if (OrderType() < 2 && OrderOpenTime() < firstTime)
                {
                  firstTime = OrderOpenTime();
                  type = OrderType();
                }
             }
       }
   }  
   return type;
}

void setTP(int type, int orderTP)
{
   double BE = calculateBreakevenPrice();
   double newTP = 0;
   
   if (type == 0)
      newTP = NormalizeDouble(BE + (orderTP * _Point),_Digits);
   else if (type == 1)
      newTP = NormalizeDouble(BE - (orderTP * _Point),_Digits);
               
   for(int x = OrdersTotal() - 1; x >= 0 ; x--)
   {
       if (OrderSelect(x, SELECT_BY_POS, MODE_TRADES))
       { 
             if (OrderSymbol() == Symbol() && OrderType() == type)
             {
                  if (OrderTakeProfit() < newTP - _Point || OrderTakeProfit() > newTP + _Point)
                  {
                     bool res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),newTP,NULL);
                     if(!res)
                        Print("Error in OrderModify. TP " + DoubleToString(newTP) + " Error code=",GetLastError());
                  }
             }
       }
   }
}

void setSL(double BE)
{
if(EnableSL)
   {
   int type = getFirstOrderType();
   double newSL = 0;
   if (type == 0)
      bsl = NormalizeDouble(BE - (mSL* _Point),_Digits);
   else if (type == 1)
      ssl = NormalizeDouble(BE + (mSL* _Point),_Digits);
   }       
}

void mo1()
  {
   double sbs=bsl;
   if(bs()>1 && bsl!=0)
      sbs=bsl-(rSL/2)*_Point*10;
   double sss=ssl;
   if(ss()>1 && ssl!=0)
      sss=ssl+(rSL/2)*_Point*10;
   for(int i=0; i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY)//(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
              {
               if(OrderStopLoss()!=sbs && bsl!=0)
                 {
                  bool m1=OrderModify(OrderTicket(),OrderOpenPrice(),sbs,OrderTakeProfit(),0,clrNONE);
                  if(bsl!=0)
                    {
                     sbs=sbs+(rSL/(bs()))*_Point*10;
                     if(sbs>bsl+(rSL/2)*_Point*10)
                        sbs=bsl+(rSL/2)*_Point*10;
                    }
                 }
              }
            else if(OrderType()==OP_SELL)//(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
              {
               if(OrderStopLoss()!=sss && ssl!=0)
                 {
                  bool m3=OrderModify(OrderTicket(),OrderOpenPrice(),sss,OrderTakeProfit(),0,clrNONE);
                  if(ssl!=0)
                    {
                     sss=sss-(rSL/(ss()))*_Point*10;
                     if(sss<ssl-(rSL/2)*_Point*10)
                        sss=ssl-(rSL/2)*_Point*10;
                    }
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
void mo()
  {
   double tbs=btp;
   if(bs()>1 && btp!=0)
      tbs=btp-(rTP/2)*_Point*10;
   double tss=stp;
   if(ss()>1 && stp!=0)
      tss=stp+(rTP/2)*_Point*10;
   for(int i=0; i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol())
           {
            if(OrderType()==OP_BUY)//(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
              {
               if(OrderTakeProfit()!=tbs && btp!=0)
                 {
                  bool m0=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tbs,0,clrNONE);
                  if(btp!=0)
                    {
                     tbs=tbs+(rTP/(bs()))*_Point*10;
                     if(tbs>btp+(rTP/2)*_Point*10)
                        tbs=btp+(rTP/2)*_Point*10;
                    }
                 }
              }
            else if(OrderType()==OP_SELL)//(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
              {
               if(OrderTakeProfit()!=tss && stp!=0)
                 {
                  bool m2=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tss,0,clrNONE);
                  if(stp!=0)
                    {
                     tss=tss-(rTP/(ss()))*_Point*10;
                     if(tss<stp-(rTP/2)*_Point*10)
                        tss=stp-(rTP/2)*_Point*10;
                    }
                 }
              }
           }
        }
     }
  }
  
int ss()
  {
   int s=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      int a=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol())s++;
     }
   return(s);
  }

int bs()
  {
   int s=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      int a=OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol())s++;
     }
   return(s);
  }
  

  //+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates()
  {
//--- refresh rates
   if(!m_symbol.RefreshRates())
     {
      Print("RefreshRates error");
      return(false);
     }
//--- protection against the return value of "zero"
   if(m_symbol.Ask()==0 || m_symbol.Bid()==0)
      return(false);
//---
   return(true);
  }
//+------------------------------------------------------------------+
//| Check the correctness of the order volume                        |
//+------------------------------------------------------------------+
bool CheckVolumeValue(double volume,string &error_description)
  {
//--- minimal allowed volume for trade operations
   double min_volume=m_symbol.LotsMin();
   if(volume<min_volume)
     {
      error_description=StringFormat("Volume is less than the minimal allowed SYMBOL_VOLUME_MIN=%.2f",min_volume);
      return(false);
     }

//--- maximal allowed volume of trade operations
   double max_volume=m_symbol.LotsMax();
   if(volume>max_volume)
     {
      error_description=StringFormat("Volume is greater than the maximal allowed SYMBOL_VOLUME_MAX=%.2f",max_volume);
      return(false);
     }

//--- get minimal step of volume changing
   double volume_step=m_symbol.LotsStep();

   int ratio=(int)MathRound(volume/volume_step);
   if(MathAbs(ratio*volume_step-volume)>0.0000001)
     {
      error_description=StringFormat("Volume is not a multiple of the minimal step SYMBOL_VOLUME_STEP=%.2f, the closest correct volume is %.2f",
                                     volume_step,ratio*volume_step);
      return(false);
     }
   error_description="Correct volume value";
   return(true);
  }
//+------------------------------------------------------------------+ 
//| Checks if the specified filling mode is allowed                  | 
//+------------------------------------------------------------------+ 
bool IsFillingTypeAllowed(int fill_type)
  {
//--- Obtain the value of the property that describes allowed filling modes 
   int filling=m_symbol.TradeFillFlags();
//--- Return true, if mode fill_type is allowed 
   return((filling & fill_type)==fill_type);
  }
//+------------------------------------------------------------------+

bool HLineCreate(const long            chart_ID=0,        // chart's ID 
                 const string          name="HLine",      // line name 
                 const int             sub_window=0,      // subwindow index 
                 double                price=0,           // line price 
                 const color           clr=clrRed,        // line color 
                 const ENUM_LINE_STYLE style=STYLE_SOLID, // line style 
                 const int             width=1,           // line width 
                 const bool            back=false,        // in the background 
                 const bool            selection=true,    // highlight to move 
                 const bool            hidden=true,       // hidden in the object list 
                 const long            z_order=0)         // priority for mouse click 
  {
//--- if the price is not set, set it at the current Bid price level 
   if(!price)
      price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
//--- reset the error value 
   ResetLastError();
//--- create a horizontal line 
   if(!ObjectCreate(chart_ID,name,OBJ_HLINE,sub_window,0,price))
     {
      Print(__FUNCTION__,
            ": failed to create a horizontal line! Error code = ",GetLastError());
      return(false);
     }
//--- set line color 
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- set line display style 
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//--- set line width 
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
//--- display in the foreground (false) or background (true) 
//   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
////--- enable (true) or disable (false) the mode of moving the line by mouse 
////--- when creating a graphical object using ObjectCreate function, the object cannot be 
////--- highlighted and moved by default. Inside this method, selection parameter 
////--- is true by default making it possible to highlight and move the object 
//   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
//   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
////--- hide (true) or display (false) graphical object name in the object list 
//   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
////--- set the priority for receiving the event of a mouse click in the chart 
//   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- successful execution 
   return(true);
  }
//+------------------------------------------------------------------+ 
//| Move horizontal line                                             | 
//+------------------------------------------------------------------+ 
bool HLineMove(const long   chart_ID=0,   // chart's ID 
               const string name="HLine", // line name 
               double       price=0)      // line price 
  {
//--- if the line price is not set, move it to the current Bid price level 
   if(!price)
      price=SymbolInfoDouble(Symbol(),SYMBOL_BID);
//--- reset the error value 
   ResetLastError();
//--- move a horizontal line 
   if(!ObjectMove(chart_ID,name,0,0,price))
     {
      Print(__FUNCTION__,
            ": failed to move the horizontal line! Error code = ",GetLastError());
      return(false);
     }
//--- successful execution 
   return(true);
  }
//+------------------------------------------------------------------+ 
//| Delete a horizontal line                                         | 
//+------------------------------------------------------------------+ 
bool HLineDelete(const long   chart_ID=0,   // chart's ID 
                 const string name="HLine") // line name 
  {
//--- reset the error value 
   ResetLastError();
//--- delete a horizontal line 
   if(!ObjectDelete(chart_ID,name))
     {
      Print(__FUNCTION__,
            ": failed to delete a horizontal line! Error code = ",GetLastError());
      return(false);
     }
   return(true);
   }
 